=== debian/changelog ===
g2clib (2.2.0-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Aug 2025 09:34:33 +0100

g2clib (2.2.0-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 02 May 2025 11:00:37 +0100

g2clib (2.1.0-2) unstable; urgency=medium

  * Standards-Version: 4.7.2
  * Drop man page second.3.gz. Closes: #1102704

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 24 Apr 2025 08:02:12 +0100
