=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -179,6 +179,7 @@
 g2c_test(tst_g2_create)
 g2c_test(tst_g2_addgrid)
 g2c_test(tst_g2_addfield)
+g2c_test(tst_rare_packing_gribend)
 g2c_test(tst_decode)
 g2c_test(tst_gbits)
 g2c_test(tst_gridtemplates)
