=== debian/changelog ===
g2clib (2.3.0-4) unstable; urgency=medium

  * Fix to ntoh64 patch for s390x (big-endian 64-bit)

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Jan 2026 14:32:40 +0000

g2clib (2.3.0-3) unstable; urgency=medium

  * d/watch: Move to version 5 syntax
  * Move d/copyright to DEP-5
  * Standards-Version: 4.7.3
  * Drop Priority: optional from source in d/control per new policy
  * Fix for 32-bit systems: use uint64_t not size_t
  * OpenJPEG  breaks on 32-bit archs (and others); avoid

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 06 Jan 2026 16:16:28 +0000

g2clib (2.3.0-2) unstable; urgency=medium

  * Fix typo in comments that breaks doxygen. Closes: #1122415
  * Drop obsolete bug report, mostly fixed? Closes: #977942
  * No longer ignore test failures

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 13 Dec 2025 09:13:19 +0000

g2clib (2.3.0-1) unstable; urgency=medium

  * New upstream release
  * Move d/watch to version 4 syntax

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 07 Nov 2025 08:59:26 +0000
