=== debian/control ===
Source: g2clib
Section: utils
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat  (= 13), 
 cmake,
 libpng-dev, 
 libaec-dev,
 zlib1g-dev, 
 pkgconf,
 doxygen,
 libopenjp2-7-dev 
Standards-Version: 4.7.3
Homepage: https://github.com/NOAA-EMC/NCEPLIBS-g2c
Vcs-Browser: https://salsa.debian.org/science-team/g2clib
Vcs-Git: https://salsa.debian.org/science-team/g2clib.git -b debian/latest

Package: libg2c0
Section: libs
Architecture: any
Breaks: libg2c0d
Replaces: libg2c0d
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: NCEP GRIB2 encoder/decoder library
 This is the libg2c library from NCEP for encoding and decoding 'GRIB2'
 data formats. 

Package: libg2c-utils
Architecture: any
Depends:  libg2c0 ( = ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: NCEP GRIB2 library - development files
 This is the libg2c library from NCEP for encoding and
 decoding 'GRIB2' data formats.
 .
 This package  contains the g2c_compare, g2c_degrib2 and g2c_index utilites.

Package: libg2c-dev
Section: libdevel
Architecture: any
Depends: libg2c0 ( = ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Recommends: pkgconf
Description: NCEP GRIB2 library - development files
 This is the libg2c library from NCEP for encoding and
 decoding 'GRIB2' data formats.
 .
 This package contains the static libraries and headers needed to build 
 applications against libg2c.
