=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/NOAA-EMC/NCEPLIBS-g2c
